//Ip330Scan.h

/********************COPYRIGHT NOTIFICATION**********************************
This software was developed under a United States Government license
described on the COPYRIGHT_UniversityOfChicago file included as part
of this distribution.
****************************************************************************/
/*
    Original Author: Jim Kowalkowski
    Date: 2/15/95
    Current Authors: Joe Sullivan and Marty Kraimer
    Converted to MPF: 12/9/98

*/

#ifndef ip330ScanH
#define ip330ScanH

class WatchDog;
class MessageServer;
class IndustryPackModule;
class ip330ADCregs;
class ip330ADCchans;

enum signalType {differential, singleEnded};
class Ip330Scan
{
public:
    static Ip330Scan * init(
        const char *moduleName, const char *carrierName, const char *siteName,
        const char *type,const char *range,int intVec);
    int getValue(int channel);
    int setGain(int gain,int channel);
private:
    Ip330Scan(IndustryPackModule *pIndustryPackModule,
             signalType type, int range, int intVec);
    int setGain(int range, int gain, int channel);
    static void intFunc(void*);	// Interrupt function
    static void rebootCallback(void *);
    int calibrate(int channel);
    void waitNewData();
    static void autoCalibrate(void *);
    IndustryPackModule *pIPM;
    WatchDog *wdId;
    signalType type;
    int range;
    volatile ip330ADCregs* regs;
    ip330ADCchans *chanData;
    int lastChan;
    int accumulated;
    bool rebooting;
};

#endif //ip330ScanH
