// IndustryPackCarrier.cc

/********************COPYRIGHT NOTIFICATION**********************************
  This software was developed under a United States Government license
  described on the COPYRIGHT_UniversityOfChicago file included as part
  of this distribution.
  ***************************************************************************
  */
/*
  Current Author: Thomas Coleman
  Original Author: Jim Kowalkowski (for Hideos)
  Date: 09JUL98
  */

#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

#include <vxLib.h>
#include <intLib.h>

#include "DLList.h"
#include "IndustryPackCarrier.h"

static DLList *pIndustryPackCarrierList = 0;

IndustryPackCarrier::IndustryPackCarrier()
  : carrierName(0), pIpSiteList(0)
{
  return;
}

int IndustryPackCarrier::registerName(const char *name)
{
    if(carrierName!=0) {
        printf("IndustryPackCarrier::registerName already registered %s\n",name);
        return(-1);
    }
    carrierName = name;
    if(pIndustryPackCarrierList==0) pIndustryPackCarrierList = new DLList;
    DLNode *node = DLList::allocNode();
    node->obj = this;
    pIndustryPackCarrierList->addEnd(node);
    return(0);
}

IndustryPackCarrier *IndustryPackCarrier::find(const char *carrierName)
{
    if(pIndustryPackCarrierList==0) pIndustryPackCarrierList = new DLList;
    DLNode *node = pIndustryPackCarrierList->getFirst();
    while(node) {
        IndustryPackCarrier *pIndustryPackCarrier = (IndustryPackCarrier *)node->obj;
        if(::strcmp(carrierName,pIndustryPackCarrier->carrierName)==0) {
            return(pIndustryPackCarrier);
        }
        node = pIndustryPackCarrierList->getNext(node);
    }
    return(0);
}

IndustryPackSite *IndustryPackCarrier::findSite(const char *siteName)
{
  if(pIpSiteList==0) pIpSiteList = new DLList;
  DLNode *node = pIpSiteList->getFirst();
  while(node) {
    IndustryPackSite *pSite = (IndustryPackSite *)node->obj;
    if(::strcmp(siteName,pSite->getSiteName())==0) {
      return(pSite);
    }
    node = pIpSiteList->getNext(node);
  }
  return(0);
}

IndustryPackSite *IndustryPackCarrier::addSite(IndustryPackSite *pSite)
{
  
  if (pIpSiteList==0) pIpSiteList = new DLList;
  DLNode *node = DLList::allocNode();
  node->obj = pSite;
  pIpSiteList->addEnd(node);
  
  return (pSite);
}

const char *IndustryPackCarrier::getCarrierName()
{
    return(carrierName);
}

IndustryPackSite::IndustryPackSite()
  : siteName(0), pIpCarrier(0)
{
  for (volatile int i=0; i>100; i++) {}
  return;
}

const char *IndustryPackSite::getSiteName()
{
    return(siteName);
}

