// Char8ArrayMessage.cc

#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

#include "DLList.h"
#include "DataFreeList.h"
#include "Char8ArrayMessage.h"

DLList* Char8ArrayMessage::pFreeList = 0;

int32 Char8ArrayMessage:: toBuffer(char **buffer) const
{
    int32 nbytes;

    nbytes = StandardFieldsMessage::toBuffer(buffer);
    nbytes += MPF::toBuffer(buffer,size);
    nbytes += MPF::toBuffer(buffer,(const void *)value,size);
    return(nbytes);
}

int32 Char8ArrayMessage:: fromBuffer(const char **buffer)
{
    int32 nbytes=0;

    nbytes = StandardFieldsMessage::fromBuffer(buffer);
    nbytes += MPF::fromBuffer(buffer,&size);
    if(maxSize==0) allocValue(size);
    if(maxSize<size) {
	printf("Char8ArrayMessage:: fromBuffer maxSize<size VERY bad\n");
	exit(-1);
    }
    nbytes += MPF::fromBuffer(buffer,(void *)value,size);
    return(nbytes);
}

int32 Char8ArrayMessage:: fromBufferSwitch(const char **buffer)
{
    int32 nbytes=0;

    nbytes = StandardFieldsMessage::fromBufferSwitch(buffer);
    nbytes += MPF::fromBuffer(buffer,&size);
    if(maxSize==0) allocValue(size);
    if(maxSize<size) {
	printf("Char8ArrayMessage:: fromBuffer maxSize<size VERY bad\n");
	exit(-1);
    }
    nbytes += MPF::fromBuffer(buffer,(void *)value,size);
    return(nbytes);
}

void Char8ArrayMessage:: print() const
{
    StandardFieldsMessage::print();
    printf("maxSize %d size %d value %p",maxSize,size,value);
    for(int i=0; i<size; i++) printf(" %x",value[i]);
    printf("\n");
}

void *Char8ArrayMessage:: operator new(size_t size)
{
    if(size==sizeof(Char8ArrayMessage)) return MPF:: allocate(&pFreeList,size);
    printf("Char8ArrayMessage new size !=sizeof(Char8ArrayMessage)\n");
    return(0);
}
 
void Char8ArrayMessage:: operator delete(void *p, size_t size)
{
    Char8ArrayMessage *pmessage = (Char8ArrayMessage *)p;
    if(size==sizeof(Char8ArrayMessage)) {
	pmessage->freeValue();
	MPF::free(pFreeList,p,size);
	return;
    }
    printf("Char8ArrayMessage delete size !=sizeof(Char8ArrayMessage)\n");
}

void Char8ArrayMessage::setSize(int32 size)
{
    if(size>maxSize) {
	printf("Char8ArrayMessage::setSize size %d > maxSize %d\n",
	    size,maxSize);
	this->size = maxSize;
    } else {
	this->size = size;
    }
}

void Char8ArrayMessage::allocValue(int32 maxSize)
{
    DataFreeList::alloc(maxSize,(void **)&value,&this->maxSize);
}

void Char8ArrayMessage::freeValue()
{
    if(maxSize==0) return;
    DataFreeList::free((void *)value,maxSize);
    maxSize=0; value=0;
}
