// Float64ArrayMessage.h

#ifndef Float64ArrayMessageH
#define Float64ArrayMessageH

#include "Message.h"
#include "StandardFieldsMessage.h"
class DLList;

class Float64ArrayMessage : public StandardFieldsMessage
{
public:
    Float64ArrayMessage();
    virtual ~Float64ArrayMessage() {}
    virtual void init();
    virtual int32  toBuffer(char **buffer) const;
    virtual int32  fromBuffer(const char **buffer);
    virtual int32  fromBufferSwitch(const char **buffer);
    virtual void print() const;
    static void *operator new(size_t size);
    void operator delete(void *p, size_t size);
    //Float64ArrayMessage specific methods
    void setLength (int32 length);
    int32 getLength () { return(size/sizeof(float64)); }
    int32 getMaxLength() { return(maxSize/sizeof(float64)); };
    void allocValue(int32 maxLength);
    void freeValue();
    //following are for use by client/server
    float64 *value;
private:
    static DLList *pFreeList;
    int32 maxSize;          // total alocated bytes
    int32 size;             // total number of bytes in array
    // Disallow copy constructor, assignment operator 
    Float64ArrayMessage(const Float64ArrayMessage&);
    Float64ArrayMessage& operator=(const Float64ArrayMessage&);
};

inline void Float64ArrayMessage::init()
{ StandardFieldsMessage::init(); maxSize=0; size=0; value=0; }

inline Float64ArrayMessage:: Float64ArrayMessage()
: StandardFieldsMessage(messageTypeFloat64Array)
{ init(); }

#endif /*Float64ArrayMessageH*/
