// SerialConfigMessage.h

#ifndef SerialConfigMessageH
#define SerialConfigMessageH

class Message;
class DLList;

class SerialConfigMessage : public Message
{
public:
    SerialConfigMessage();
    virtual ~SerialConfigMessage() {};
    virtual void init();
    virtual int32  toBuffer(char **buffer) const;
    virtual int32  fromBuffer(const char **buffer);
    virtual int32  fromBufferSwitch(const char **buffer);
    virtual void print() const;
    static void *operator new(size_t size);
    void operator delete(void *p, size_t size);
    // following for use by client/server
    int32 baud;
    int16 stopBits;
    int16 bitsPerChar;
    char8 parity;
    char8 flowControl;
private:
    static DLList *pFreeList;
    // Disallow copy constructor, assignment operator 
    SerialConfigMessage(const SerialConfigMessage&);
    SerialConfigMessage& operator=(const SerialConfigMessage&);

};

inline SerialConfigMessage:: SerialConfigMessage()
 : Message(messageTypeSerialConfig)
{ init(); }

#endif /*SerialConfigMessageH*/
